/* $Id: disasmonly.c,v 1.1 1996/11/07 08:03:30 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	PȂtAZuW[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include    <stdio.h>
#include    <string.h>	/* strcmp memcmp strlen */
#include    <ctype.h>	/* tolower */

#include    "disasm.h"
#include    "estruct.h"
#include    "etc.h"
#include    "generate.h"
#include    "global.h"
#include    "hex.h"
#include    "output.h"


USEOPTION   option_x;

extern char IOCSCallName[ 16 ];


INLINE static char *strcpy2( char *dest , char *source )
{
    while( ( *dest++ = *source++ ) != 0 )
	;
    return --dest;
}


private int disasm1line (address pc, address pcend)
{
    char    buffer[256];
    char    *ptr = buffer;
    address store, store0, pc0;
    disasm  code;
    int     iocsno;
    int     bytes;

    pc0 = pc;
    store = store0 = pc + Ofst;
    store += bytes = dis( store , &code , &pc );
    modify_operand (&code);

    *ptr++ = '\t';

    if( code.flag == OTHER &&
      *(UBYTE*)store0 == 0x70 &&	/* 0x70xx == moveq.l #xx,d0 */
      *(UWORD*)store == 0x4e4f &&	/* 0x4e4f == TRAP #15 opecode */
      IOCSlabel[ iocsno = (int)*(UBYTE*)( store0 + 1 ) ] && (pc < pcend) ) {
	ptr = strcpy2 (ptr, IOCSCallName);
	*ptr++ = '\t';
	strcpy2 (ptr, IOCSlabel[iocsno]);
	store += 2;
	pc += 2;
	bytes += 2;
    } else {
	ptr = strcpy2 (ptr, code.opecode);
	if (code.size < NOTHING) {
	    *ptr++ = '.';
	    *ptr++ = opsize[code.size];
	}

	if (code.op1.operand[0]) {
	    *ptr++ = '\t';
	    ptr = strcpy2 (ptr, code.op1.operand);

	    if (code.op2.operand[0]) {
		if ((code.op2.ea != BitField) && (code.op2.ea != KFactor))
		    *ptr++ = ',';
		ptr = strcpy2 (ptr, code.op2.operand);

		if (code.op3.operand[0]) {
		    if ((code.op3.ea != BitField) && (code.op3.ea != KFactor))
			*ptr++ = ',';
		    ptr = strcpy2 (ptr, code.op3.operand);

		    if (code.op4.operand[0]) {
			if ((code.op4.ea != BitField) && (code.op4.ea != KFactor))
			    *ptr++ = ',';
			ptr = strcpy2 (ptr, code.op4.operand);
		    }
		}
	    }
	}
    }

    if( option_x )
	byteout_for_xoption( pc0 , store - store0 , buffer );

    outputa( buffer );
    newline( store0 - Ofst );

    if( ( code.flag == RTSOP )
     || ( code.flag == JMPOP && tolower( code.opecode[0] ) == 'j' ) )
	outputa( CR );			/* RTŠɂ͋s */

    return bytes;
}


/*

 PȂtAZu

*/
extern void disasmlist( char *xfilename , char *sfilename , time_t filedate )
{
    address pc = BeginTEXT;
#ifdef	OSKDIS
    address pcend = BeginBSS;
#else
    address pcend = BeginDATA;
#endif	/* OSKDIS */

    if( option_x )
	Atab += 2;

    init_output();
    output_file_open( sfilename , 0 );

    PCEND = pcend;
    while (pc < pcend) {
	char	adrs[8];
	itox6( adrs , (ULONG)pc );
	outputa( adrs );
	pc += disasm1line (pc, pcend);
    }

    output_file_close();
}


/* EOF */
