/*
 *
 *	\[XR[hWFl[^
 *	_lϊW[
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

/* System headers */
#include <stdio.h>	/* sprintf() */

/* Headers */
#include "estruct.h"	/* enum boolean */
#include "hex.h"	/* itox8_without_0supress() */
#include "fpconv.h"


/* External variables */
short	Inreal_flag = FALSE;


/* Functions */
extern void
fpconv_s (char* buf, float* valp)
{
    unsigned long expmant = *(unsigned long*)valp & 0x7fffffff;

    if ( Inreal_flag
      || (0x7f800000 <= expmant)			/* A */
      || ((expmant <= 0x007fffff) && (expmant != 0)) )	/* 񐳋K */
    {
	*buf++ = '!';			/* ȒlȂ\ŏo */
	itox8_without_0supress (buf, *(long*)valp);
    } else {
	sprintf (buf, "0f%.30g", *valp);
    }
}


/* Functions */
extern void
fpconv_d (char* buf, double* valp)
{
    unsigned long hi = ((unsigned long*)valp)[0] & 0x7fffffff;
    unsigned long lo = ((unsigned long*)valp)[1];

    if ( Inreal_flag
      || (0x7ff00000 <= hi)				/* A */
      || ((hi <= 0x000fffff) && (hi|lo != 0)) )		/* 񐳋K */
    {
	*buf++ = '!';			/* ȒlȂ\ŏo */
	buf = itox8_without_0supress (buf, *(long*)valp);
	*buf++ = '_';
	(void)itox8_without_0supress (buf, lo);
    } else {
	sprintf (buf, "0f%.30g", *valp);
    }
}


#ifdef	NO_LDBL_DOPRNT
/* Functions */
extern void
fpconv_x (char* buf, long double* valp)
{
    unsigned long* ptr = (unsigned long*)valp;

    *buf++ = '!';
    buf = itox8_without_0supress (buf, *ptr++);
    *buf++ = '_';
    buf = itox8_without_0supress (buf, *ptr++);
    *buf++ = '_';
    (void)itox8_without_0supress (buf, *ptr++);
}
#else
extern void
fpconv_x (char* buf, long double* valp)
{
    unsigned long* ptr = (unsigned long*)valp;
    unsigned short exp = ((unsigned short*)valp)[0] & 0x7fff;

    if ( Inreal_flag
      || (exp == 0x7fff)				/* A */
      || ((exp == 0) && (ptr[1] || ptr[2]))		/* 񐳋K */
#if 1
      || (exp && (exp < 0x0030))	/* 񐳋Kԍ(CuɈˑ) */
#endif
      || ((unsigned short*)valp)[1]			/* gprbgZbg */
      || (((char*)valp)[4] >= 0) )			/* rbg0 */
    {
	*buf++ = '!';			/* ȒlȂ\ŏo */
	buf = itox8_without_0supress (buf, *ptr++);
	*buf++ = '_';
	buf = itox8_without_0supress (buf, *ptr++);
	*buf++ = '_';
	(void)itox8_without_0supress (buf, *ptr++);

    } else
	sprintf (buf, "0f%.30Lg", *valp);
}
#endif	/* NO_LDBL_DOPRNT */


/* File scope functions */
static boolean
is_normalized_p (packed_decimal* valp)
{

    if ((valp->ul.hi<<1 | valp->ul.mi | valp->ul.lo) == 0)
	return TRUE;					/* }0.0 */

    if ( ((valp->ul.hi & 0x7fff0000) == 0x7fff0000)	/* , */
      || ((valp->ul.hi & 0x3000fff0) != 0)		/* gprbgZbg */
#if 0
      || ((valp->ul.hi & 0x4fff0000) == 0x4fff0000)	/* 񐳋K */
#endif
      || ((valp->ul.hi & 0x0000000f) > 9) )		/* BCD()̒lُ */
	return FALSE;

    {
	int i;
	unsigned char *ptr = &valp->uc[4];
	for (i = 0; i < 8; i++) {
	    unsigned char c = *ptr++;
	    if ((c > (unsigned char)0x99) || ((c & 0x0f) > (unsigned char)0x09))
		return FALSE;				/* BCD()̒lُ */
	}
    }

   return TRUE;
}


/* Functions */
extern void
fpconv_p (char* buf, packed_decimal* valp)
{

    if ( Inreal_flag || !is_normalized_p (valp)) {

	*buf++ = '!';			/* ȒlȂ\ŏo */
	buf = itox8_without_0supress (buf, valp->ul.hi);
	*buf++ = '_';
	buf = itox8_without_0supress (buf, valp->ul.mi);
	*buf++ = '_';
	(void)itox8_without_0supress (buf, valp->ul.lo);

    } else {
	*buf++ = '0';
	*buf++ = 'f';
	if (valp->uc[0] & 0x80)
	    *buf++ = '-';

	/* ̐ */
	*buf++ = '0' + (valp->ul.hi & 0x0000000f);
	*buf++ = '.';

	/* ̏ */
	{
	    int i;
	    unsigned char *ptr = &valp->uc[4];

	    for (i = 0; i < 8; i++) {
		unsigned char c = *ptr++;
		*buf++ = '0' + (c >> 4);
		*buf++ = '0' + (c & 0x0f);
	    }
	}

	/* '0'폜 */
	while (*--buf == (char)'0')
	    ;
	if (*buf != (char)'.')
	    buf++;

	/* w */
	{
	    int expo = (valp->uc[0] & 0x0f)*100
		     + (valp->uc[1] >> 4)*10
		     + (valp->uc[1] & 0x0f);

	    if ((expo == 0) && !(valp->uc[0] & 0x40)) {
		/* "e+0"͏ȗ */
		*buf = '\0';
	    } else {
		*buf++ = 'e';
		*buf++ = (valp->uc[0] & 0x40) ? '-' : '+';
		buf += (expo >= 100) + (expo >= 10) + 1;
		*buf = '\0';
		do {
		    *--buf = '0' + (expo % 10);
		    expo /= 10;
		} while (expo);
	    }
	}
    }
}


/* Functions */
extern void
fpconv_q (char* buf, quadword* valp)
{
    *buf++ = '!';
    buf = itox8_without_0supress (buf, valp->ul.hi);
    *buf++ = '_';
    (void)itox8_without_0supress (buf, valp->ul.lo);
}


/* EOF */
