/* $Id: include.c,v 1.1 1996/11/07 08:03:42 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	CN[ht@Cǂݍ݃W[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include	<stdio.h>
#include	<stdlib.h>	/* getenv */
#include	<string.h>

#include	"disasm.h"	/* OSlabel , FElabel , SXlabel */
#include	"estruct.h"
#include	"etc.h"
#include	"generate.h"	/* IOCSlabel */
#include	"global.h"
#include	"include.h"


#ifdef	OSKDIS
char	OS9_mac_path[MAX_INCLUDE_FILE_PATH];
char	MATH_mac_path[MAX_INCLUDE_FILE_PATH];
char	CIO_mac_path[MAX_INCLUDE_FILE_PATH];
#else
char	Doscall_mac_path[MAX_INCLUDE_FILE_PATH];
char	Iocscall_mac_path[MAX_INCLUDE_FILE_PATH];
char	Fefunc_h_path[MAX_INCLUDE_FILE_PATH];
char	*Sxcall_mac_path;
#endif	/* OSKDIS */

/* static ֐vg^Cv */
private int	readfile( char* , char** , int , char* );
private int	getlabel( char* , char** , int , char* );
extern void	*strndup( char *string , int length );

/*

  doscall.mac iocscall.mac fefunc.h ϐ include ɂēǂݍ

*/
extern void	load_OS_sym()
{
    char	*inc , *dis_inc;
    char	*sx_mac;			/* SX window macro-def file(full path) */
    int		i;

#ifdef	OSKDIS
    for( i = 0 ; i < 256 ; i++ ) {		/* initialize */
		OS9label[i] = MATHlabel[i] = CIOlabel[i] = NULL;
    }

	if ((dis_inc = getenv( "DISDEFS" )) == NULL) {
/*		err(1, "ϐ DISDEFS ݒ肳Ă܂\n");	*/
		eprintf( "ϐ DISDEFS ݒ肳Ă܂\n");
	}
	else {
		if ( readfile(strcat(strcpy(OS9_mac_path, dis_inc), "/os9defs.d"),
			OS9label, 0, "OS9") ) {
/*			err(1, "os9defs.d I[vo܂\n");	*/
			eprintf( "os9defs.d I[vo܂\n");
		}

		if ( readfile(strcat(strcpy(MATH_mac_path, dis_inc), "/mathdefs.d"),
			MATHlabel, 0, "T$Math") ) {
/*			err(1, "mathdefs.d I[vo܂\n");	*/
			eprintf( "mathdefs.d I[vo܂\n");
		}

		if ( readfile(strcat(strcpy(CIO_mac_path, dis_inc), "/ciodefs.d"),
			CIOlabel, 0, "CIO$Trap") ) {
/*			err(1, "ciodefs.d I[vo܂\n");	*/
			eprintf( "ciodefs.d I[vo܂\n");
		}
	}
#else
    for( i = 0 ; i < 256 ; i++ ) {		/* initialize */
	OSlabel[i] = FElabel[i] = IOCSlabel[i] = NULL;
    }

    dis_inc = getenv( "dis_include" );
    inc = getenv( "include" );
    Sxcall_mac_path = sx_mac = getenv( "dis_sxmac" );

    if( dis_inc == NULL && inc == NULL )
	err( 1 , "ϐ (dis_)include ݒ肳Ă܂\n" );

    if( ( dis_inc == NULL ||
	  readfile( strcat( strcpy( Doscall_mac_path , dis_inc ) , "/doscall.mac" ) ,
		   OSlabel , 0xff , OSCallName ) ) &&
	(     inc == NULL ||
	 readfile( strcat( strcpy( Doscall_mac_path ,     inc ) , "/doscall.mac" ) ,
		  OSlabel , 0xff , OSCallName ) ) )
	err( 1 , "doscall.mac I[vo܂\n" );

    if( ( dis_inc == NULL ||
	  readfile( strcat( strcpy( Iocscall_mac_path , dis_inc ) , "/iocscall.mac" ) ,
		   IOCSlabel , 0 , IOCSCallName ) ) &&
	(     inc == NULL ||
	 readfile( strcat( strcpy( Iocscall_mac_path ,     inc ) , "/iocscall.mac" ) ,
		  IOCSlabel , 0 , IOCSCallName ) ) )
	err( 1 , "iocscall.mac I[vo܂\n" );

#define	READFE( env , file ) \
	readfile( strcat( strcpy( Fefunc_h_path , env ) , file ) ,\
		  FElabel , 0xfe , FECallName )

    if( ( dis_inc == NULL || ( READFE( dis_inc , "/fefunc.dis" )
			    && READFE( dis_inc , "/fefunc.h" ) ) ) &&
	(     inc == NULL || ( READFE(     inc , "/fefunc.dis" )
			    && READFE(     inc , "/fefunc.h" ) ) ) )
	err( 1 , "fefunc.dis , fefunc.h I[vo܂\n" );

#undef	READFE

    if( Sxcall_mac_path ) {
	char **ptr;
	ptr = SXlabel = (char **)Malloc( sizeof(char *) * SXCALL_MAX );
	for( i = 0 ; i < SXCALL_MAX ; i++ )
	    *ptr++ = NULL;

	if( readfile( Sxcall_mac_path , SXlabel, 0xa , SXCallName ) )
	    err( 1 , "%s I[vo܂\n" , Sxcall_mac_path );
    }
#endif	/* OSKDIS */
}


private int	readfile( char *filename , char *label[] , int hbyte , char *callname )
{
    char	linebuf[128];
    FILE	*fp;
    int		label_num = 0;

    if( ( fp = fopen( filename , "rt" )) == NULL )
	return 1;

    eprintf( "Reading %s...\n" , filename );
    while( 1 ) {
	if( ( fgets( linebuf , sizeof linebuf , fp )) == NULL )
	    break;
	label_num += getlabel( linebuf , label , hbyte , callname );
    }
    fclose( fp );
    if( label_num == 0 )
	err( 1 , "Error : %s ɂ̓V{P`Ă܂\n" );
    return 0;
}


/*

  AZûdpt^߂̍sǂݎ
  
*/

static INLINE char *skipspc(char *ptr) {
    while( (*ptr == ' ') || (*ptr == '\t') )
	ptr++;
    return ptr;
}

static INLINE char *skipname(char *ptr) {
    while( *ptr && (*ptr != ':') && (*ptr != ' ') && (*ptr != '\t') && (*ptr != '.') )
	ptr++;
    return ptr;
}

private int	getlabel( char *linebuf , char *label[] , int hbyte , char *callname )
{

    /* s̋󔒂΂ */
    linebuf = skipspc(linebuf);

    /* sRgsȂI */
    {
	unsigned char c = *linebuf;
	if( (c < 0x20) || (c == '*') || (c == ';') || (c == '#') || (c == '.') )
	    return 0;
    }

    /* }N`s̉ */
    if( strstr( linebuf , "macro" ) != NULL ) {
	char	*callnameend;
	if( ( callnameend = strpbrk( linebuf , ": \t." ) ) == NULL )
	    err( 1 , "call macro ǂݎ܂\n" );
	strncpy( callname , linebuf , callnameend - linebuf );
	callname[ callnameend - linebuf ] = '\0';
	return 0;
    }

    /* R[ԍ`s̉ */
    if( strstr( linebuf , "equ" ) != NULL ) {
	int	labellen , val;
	char	*ptr;

	ptr = skipname(linebuf);
	labellen = ptr - linebuf;

	while( (*ptr == ':') || (*ptr == ' ') || (*ptr == '\t') || (*ptr == '.') )
	    ptr++;
	if( strnicmp( ptr, "equ", 3) != 0 )
	    return 0;			/* ς(ꉞ`FbN) */
	ptr = skipspc(ptr + 3);

	     if( (*ptr == '$') ) ptr++;
	else if( (*ptr == '0') && (*(ptr+1) == 'x') ) ptr += 2;
	else return 0;
	val = atox( ptr );

	if( hbyte != 0xa ) {
	    if( ( val >> 8 ) == hbyte )
		if( ! label[ val & 0xff ] )
		    label[ val & 0xff ] = strndup( linebuf , labellen );
	} else {
	    if( (0xa000 <= val) && (val < 0xa000 + SXCALL_MAX) )
		if( ! label[ val & 0xfff ] )
		    label[ val & 0xfff ] = strndup( linebuf , labellen );
	}
	return 1;
    }

    /* ǂɂYȂ */
    return 0;
}


extern void *strndup( char *string , int length )
{
    int  len = min( strlen( string ) , length ) + 1;
    char *rc = Malloc( len );
/*  strncpy( rc , string , length ); */
    strncpy( rc , string , len );
/*  rc[ length ]  = '\0'; */
    rc[ len - 1 ] = '\0';
    return rc;
}

/* EOF */
