/* $Id: symbol.c,v 1.1 1996/11/07 08:04:02 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	V{l[ǗW[
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include	<stdio.h>
#include	<string.h>

#include	"estruct.h"
#include	"etc.h"
#include	"global.h"
#include	"label.h"
#include	"symbol.h"


USEOPTION	option_g;


int		Symbolbufsize = 2048;	/* V{obt@̐ */
static symbol	*Symtable = NULL;	/* V{e[u̓ */
static int	Symnum;			/* V{e[u̗vf */

static const_symbol *ConstSymtable = NULL;	/* V{e[u̓ */
static int	    ConstSymnum;		/* V{e[u̗vf */


extern void	init_symtable( void )
{
    if( (( Symtable  = (symbol *)Malloc( Symbolbufsize * sizeof( symbol ) ) ) == NULL) ||
	(( ConstSymtable = (const_symbol *)Malloc( Symbolbufsize * sizeof( const_symbol ) ) ) == NULL ) )
	err( 1 , "V{e[uobt@mۏo܂ł\n" );

    Symnum = 0;
    ConstSymnum = 0;
}


/*
	st@CɕtV{e[uo^
	xt@C̓ǂݍ݂ɌĂяo
*/
extern void	make_symtable( void )
{
    char *ptr;		/* V{\ւ̃|C^ */

    ptr = (char*)( Top + Head.text + Head.data + Head.offset );
    while( (ULONG)ptr < (ULONG)( Top + Head.text + Head.data + Head.offset + Head.symbol ) ) {
	int	type;
	address	adrs;
	type = *(UWORD*)ptr;	ptr += sizeof(UWORD);
	adrs = *(address*)ptr;	ptr += sizeof(address);

	if( ( type < 0x201 ) && ( type != 3 ) )
	    add_constsymbol( adrs, ptr );
	else {
	    symbol *sym = symbol_search( adrs );
	    if( ( sym == NULL ) || ( sym->type == 0 ) )
		regist_label( adrs , DATLABEL | UNKNOWN | SYMLABEL );
	    if( !option_g )
		add_symbol( adrs , type , ptr );
	    else if( sym != NULL ) 
		sym->type = type;		/* O`V{Ɋiグ */
	}
	while( *ptr++ )
	    ;
	ptr += (long)ptr & 1;
    }
}


/*

  n

  V{XgƃV{obt@Kv邯ǎ蔲.

*/
extern void	free_symbuf( void )
{
 /* if( Symtable != NULL ) */
	Mfree( Symtable );

 /* if( ConstSymtable != NULL ) */
	Mfree( ConstSymtable );
}


/*

  adrs V{e[u{
  adrs  common text data bss ̂ꂩ
  |C^AłȂ NULL Ԃ

*/
extern symbol	*symbol_search( address adrs )
{
    int		step = Symnum >> 1;
    symbol	*ptr = Symtable;

    while( step > 4 ) {
	if( ( ptr + step )->adrs <= adrs )	/* binary search */
	    ptr += step;
	step >>= 1;
    }
    for( ; ptr < Symtable + Symnum ; ptr++ ) {
	if( ptr->adrs == adrs )
	    return ptr;
	else
	    if( adrs < ptr->adrs )
		return NULL;
    }
    return NULL;
}


extern void	add_constsymbol( address adrs , char *symstr )
{
    ConstSymtable[ ConstSymnum ].adrs = adrs;
    ConstSymtable[ ConstSymnum ].sym  = symstr;

    if( ++ConstSymnum >= Symbolbufsize )
	err( 1 , "V{e[uӂ܂\n" );
}




extern void	add_symbol( address adrs , int type , char *symstr )
{					    /* type == 0 : labelfileł̒` */
    int  i;
    symbol *sym;

#if 0
    if( type && ( type < 0x201 ) && ( type != 3 ) ) {
	add_constsymbol( adrs, symstr );
	return;
    }
#endif

    /* ɓo^ς݂Ȃ瑮ύXV{̒ǉ */
    if( ( sym = symbol_search( adrs ) ) != NULL ) {
	symlist *ptr = sym->next;
	sym->type = type;

	if( ptr == NULL )
	    ptr = sym->next = Malloc( sizeof(symlist) );
	else {
	    while( ptr->next )
		ptr = ptr->next;
	    ptr = ptr->next = Malloc( sizeof(symlist) );
	}
	ptr->next = NULL;
	ptr->sym = symstr;
	return;
    }

    for( i = Symnum - 1 ; (i >= 0) && (Symtable[ i ].adrs > adrs) ; i-- )
	Symtable[ i + 1 ] = Symtable[ i ];

#if 0
    if( (i >= 0) && (Symtable[ i ].adrs == adrs) )
	return;
#endif

    i++;
    Symtable[ i ].adrs = adrs;
    Symtable[ i ].type = (UWORD)type;
    Symtable[ i ].next = NULL;
    Symtable[ i ].sym  = symstr;

#ifdef	DEBUG
    printf( "type %4x adrs %6x sym:%s\n" , Symtable[ i ].type ,
	   Symtable[ i ].adrs , Symtable[ i ].sym );
#endif

    if( ++Symnum >= Symbolbufsize )
	err( 1 , "V{e[uӂ܂\n" );
}


#if 0
extern void	del_symbol( address adrs )
{
    symbol *sym;

    if( ( sym = symbol_search( adrs ) ) != NULL ) {
	symlist *ptr = sym->next;
	while( ptr ) {
	    symlist *next = ptr->next;
	    Mfree( ptr );
	    ptr = next;
	}

	Symnum--;
	for( ; sym < &Symtable[ Symnum ] ; sym++ )
	    *sym = *(sym + 1);
    }
}
#endif


extern boolean	is_exist_symbol( void )
{
    return Symnum ? TRUE : FALSE;
}




extern int  get_constsymbol_num( void )
{
    return ConstSymnum;
}

extern const_symbol *get_constsymbol( int i )
{
    return ConstSymtable + i;
}

/* EOF */
